//
//  AmpYoSpaceManager.h
//  AmpYoSpaceDemo
//
//  Created by Lopez Valenciano, Miguel on 2/14/17.
//  Copyright © 2017 Akamai. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "YSSessionManager.h"
#import "YoSpaceVideoPlayer.h"
#import "AmpYoSpaceObserver.h"

#if TARGET_OS_IOS
    @import AmpCore;
#endif

#if TARGET_OS_TV
    @import AmpCoreTV;
#endif

typedef NS_ENUM(NSInteger, YoSpaceStreamType) {
    VOD,
    Live,
    NonLinear,
    NoTargetType
} ;

@interface AmpYoSpaceManager : NSObject <YSSessionManagerObserver, YSAnalyticObserver, PlayerEventObserver>

- (_Nonnull id) init:(NSString* _Nonnull)url ampPlayer:(AmpPlayer * _Nonnull)ampPlayer YoSpaceProperties:(YSSessionProperties * _Nonnull) properties StreamType:(YoSpaceStreamType)type Observer:(id<AmpYoSpaceObserver> _Nonnull)observer enableLogs:(BOOL)enabled NS_DESIGNATED_INITIALIZER;

@end
